import { Test } from '@nestjs/testing';

import { AppService } from './app.service';
import { Message } from '@chat-room/api-interfaces';

describe('AppService', () => {
  let service: AppService;

  beforeAll(async () => {
    const app = await Test.createTestingModule({
      providers: [AppService],
    }).compile();

    service = app.get<AppService>(AppService);
  });

  describe('addMessage', () => {
    it('should return message', () => {
      const message: Message = {
        creationDate: new Date().toISOString(),
        message: 'Test message',
        user: 'Test User',
        color: 'Test color',
      };
      expect(service.addMessage(message)).toBe(message);
    });
  });
});
